// Sample MOD
// Demonstrates how to interact with the main application

#include <Windows.h>
#include <math.h>
#include "MODInfo.h"

// DllMain - standard DLL initializion routine
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

static DrawTextFunc_Type DrawTextFunc = NULL;
static DrawBitmapFunc_Type DrawBitmapFunc = NULL;

static int ScreenSizeX, ScreenSizeY;

// Initialize
__declspec(dllexport) bool MOD_Initialize(const MOD_InitializeData *InitInfo)
{
    DrawTextFunc = InitInfo->DrawTextFunc;
    DrawBitmapFunc = InitInfo->DrawBitmapFunc;

    ScreenSizeX = InitInfo->ScreenSizeX;
    ScreenSizeY = InitInfo->ScreenSizeY;

    char HelloStr[256];
    strcpy(HelloStr, "Welcome to Sample MOD!\n\r"
                     "Author: Dmitry Ivashkin\n\r"
                     "Date: " __DATE__ "\n\r"
                     "Game version: ");
    strcat(HelloStr, InitInfo->GameVersion);
    strcat(HelloStr, ".\n\r\n\r"
                     "Would you like to continue?");

	return (IDYES == MessageBox(NULL, HelloStr, "Sample MOD", MB_YESNO | MB_ICONINFORMATION));
}

// OnMainMenu handler - called each time main menu is being drawn
__declspec(dllexport) void MOD_OnMainMenu(float Time)
{
    if (Time > 10)
        return;

    DWORD Color;
    if (fmod(Time, 1.0f) < 0.8)
        Color = 0xFFFFFFFF;
    else
        Color = 0x80FFFFFF;

    DrawTextFunc("Sample MOD!", (int)(0.9 * ScreenSizeX), (int)(0.03f * ScreenSizeY), Color, 5);

    if (Time < 0.5)
        DrawBitmapFunc("bmp\\QXSystem\\SUNFLARE3.TGA", (int)((0.96f - 0.16f * Time) * ScreenSizeX), (int)((0.08f - 0.16f * Time) * ScreenSizeY), Time, Time);
}