#include "qall.h"
#define P( num ) Parms[ num ].ToInt()
#define PS( num ) Parms[ num ].ToStr()
#define Res LastUserFuncResult
#define Return(x) LastUserFuncResult = x;
#define ATTR(x) GetIntAttr(0, #x)
#define HAS_ATTR(x) HasAttr(0, #x)
#define SET_ATTR(x, y) SetIntAttr(0, #x, y)
#define ATTRS(x) GetStringAttr(0, #x)
#define SET_ATTRS(x, y) SetStringAttr(0, #x, y)
#include "intstrp.h"

void UserFunc(short IDCode, short ParmCount, IntStrPair *Parms, IntStrPair &LastUserFuncResult)
{
  Res = 0;
  switch (IDCode)
  {
    case GetName_Tutorial_:
      {
        #define _ININame PS(0)

    bool OK = false;

    GMList *Bind = GetMonsterBind_Tutorial(_ININame);
    if (Bind)
    {
        OK = true;
        Return(Bind->This->Name)
    }
    else
    {
        for (DeadMonsterList *Cur1 = AllDeadMonsters; Cur1; Cur1 = Cur1->Next)
        {
            if (Cur1->ININame && !strcmp(Cur1->ININame, _ININame))
            {
                OK = true;
                Return(Cur1->Name) ;
            }
        }
    }

    Assert(OK || (GameType != gtTutorial), "GetName_Tutorial - invalid ININame!");
    
    if (!OK)
    {
      Return("");
    }

        #undef _ININame
        break;
      }
    case GetName_:
      {
        #define _ININame PS(0)

        bool OK = false;

    GMList *Bind = GetMonsterBind(_ININame);
    if (Bind)
    {
        OK = true;
        Return(Bind->This->Name)
    }
    else
    {
        for (DeadMonsterList *Cur1 = AllDeadMonsters; Cur1; Cur1 = Cur1->Next)
        {
            if (Cur1->ININame && !strcmp(Cur1->ININame, _ININame))
            {
                                OK = true;
                Return(Cur1->Name);
            }
        }
    }

    Assert(OK, "GetName - invalid ININame!");
    if (!OK)
    {
      Return("");
    }

        #undef _ININame
        break;
      }
    case SetName_:
      {
        #define _ININame PS(0)
        #define name PS(1)

//    RECORDABLE
    GMList *Bind = GetMonsterBind(_ININame);
    if (Bind)
        Bind->This->SetName(name);
    else
    {
        for (DeadMonsterList *Cur1 = AllDeadMonsters; Cur1; Cur1 = Cur1->Next)
        {
            if (Cur1->ININame && !strcmp(Cur1->ININame, _ININame))
                Cur1->SetName(name);
        }
    }

        #undef _ININame
        #undef name
        break;
      }
    case GetHealth_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return((int)((100.0f * Bind->This->BodyInfo.HP / Bind->This->BodyInfo.InitHP)))
    else
        Return(-1)

        #undef ININame
        break;
      }
    case GetHealthCondition_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
    {
        int Count = 0;

        if (Bind->This->BodyInfo.LegsDamaged)  Count++;
        if (Bind->This->BodyInfo.LeftHandDamaged)  Count++;
        if (Bind->This->BodyInfo.RightHandDamaged)  Count++;
        if (Bind->This->BodyInfo.HeadDamaged)  Count++;
          
        Return(Count)
    }
    else
        Return(0)

        #undef ININame
        break;
      }
    case SetHealth_:
      {
        #define ININame PS(0)
        #define health P(1)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
    {
        if (RECORDING)
        {
            if (Bind->This->BodyInfo.HP != ((float)health / 100.0f) * Bind->This->BodyInfo.InitHP)
            {
                RECORDABLE;
            }
        }

        Bind->This->BodyInfo.HP = ((float)health / 100.0f) * Bind->This->BodyInfo.InitHP;
    }

        #undef ININame
        #undef health
        break;
      }
    case GetMoney_:
      {

    Return(App->GetEconomy()->GetMoney())

        break;
      }
    case SetMoney_:
      {
        #define NewMoney P(0)

//    RECORDABLE
    App->GetEconomy()->SetMoney(NewMoney);    

        #undef NewMoney
        break;
      }
    case GetExperience_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skExperience])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetExperience_:
      {
        #define ININame PS(0)
        #define value P(1)

//    RECORDABLE
    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skExperience] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetCharm_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skCharm])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetCharm_:
      {
        #define ININame PS(0)
        #define value P(1)

//    RECORDABLE
    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skCharm] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetLeader_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skLeader])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetLeader_:
      {
        #define ININame PS(0)
        #define value P(1)

//    RECORDABLE
    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skLeader] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetTrade_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skTrade])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetTrade_:
      {
        #define ININame PS(0)
        #define value P(1)

//    RECORDABLE
    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skTrade] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetEyeSight_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skEyeSight])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetEyeSight_:
      {
        #define ININame PS(0)
        #define value P(1)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skEyeSight] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetHearing_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skHearing])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetHearing_:
      {
        #define ININame PS(0)
        #define value P(1)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skHearing] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetLarkness_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skLarkness])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetLarkness_:
      {
        #define ININame PS(0)
        #define value P(1)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skLarkness] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetStrength_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skStrength])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetStrength_:
      {
        #define ININame PS(0)
        #define value P(1)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skStrength] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetStamina_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skStamina])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetStamina_:
      {
        #define ININame PS(0)
        #define value P(1)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skStamina] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetDexterity_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skDexterity])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetDexterity_:
      {
        #define ININame PS(0)
        #define value P(1)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skDexterity] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetAgility_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skAgility])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetAgility_:
      {
        #define ININame PS(0)
        #define value P(1)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skAgility] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetReaction_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skReaction])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetReaction_:
      {
        #define ININame PS(0)
        #define value P(1)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skReaction] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetIntellect_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skIntellect])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetIntellect_:
      {
        #define ININame PS(0)
        #define value P(1)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skIntellect] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetShooting_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skShooting])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetShooting_:
      {
        #define ININame PS(0)
        #define value P(1)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skShooting] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetSniping_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skSniping])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetSniping_:
      {
        #define ININame PS(0)
        #define value P(1)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skSniping] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetGunfighting_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skGunfighting])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetGunfighting_:
      {
        #define ININame PS(0)
        #define value P(1)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skGunfighting] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetHeavyWeapons_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skHeavyWeapons])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetHeavyWeapons_:
      {
        #define ININame PS(0)
        #define value P(1)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skHeavyWeapons] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetThrowing_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skThrowing])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetThrowing_:
      {
        #define ININame PS(0)
        #define value P(1)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skThrowing] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetHandToHand_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skHandToHand])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetHandToHand_:
      {
        #define ININame PS(0)
        #define value P(1)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skHandToHand] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetCamouflage_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skCamouflage])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetCamouflage_:
      {
        #define ININame PS(0)
        #define value P(1)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skCamouflage] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetSapper_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skSapper])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetSapper_:
      {
        #define ININame PS(0)
        #define value P(1)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skSapper] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetMedicine_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skMedicine])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetMedicine_:
      {
        #define ININame PS(0)
        #define value P(1)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skMedicine] = value;

        #undef ININame
        #undef value
        break;
      }
    case GetStealth_:
      {
        #define ININame PS(0)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Return(Bind->This->SkillInfo.Skill[skStealth])
    else
        Return(-1)

        #undef ININame
        break;
      }
    case SetStealth_:
      {
        #define ININame PS(0)
        #define value P(1)

    GMList *Bind = GetMonsterBind(ININame);
    if (Bind)
        Bind->This->SkillInfo.Skill[skStealth] = value;

        #undef ININame
        #undef value
        break;
      }
    case StdMessageBox_:
      {
        #define message PS(0)

    CallSimpleMessageBox(message);

        #undef message
        break;
      }
    case MessageBoxYesNo_:
      {
        #define message PS(0)

#ifndef _IDE
    Return((CallSimpleMessageBox(message, mbsYes | mbsNo) == mbsYes) ? Yes_ : No_);
#endif

        #undef message
        break;
      }
    case StartMessageBox_:
      {
        #define buttons P(0)

#ifndef _IDE
  MH = PrepareMessageBox(buttons);

  PhraseWaiting = false;
#endif

        #undef buttons
        break;
      }
    case NewMBText_:
      {
        #define MessageText PS(0)

#ifndef _IDE
  if (!MH)
  {
    MH = PrepareMessageBox(mbsOK);

    AddPhraseToMH("");
    PhraseWaiting = false;
  }
  else
  {
    if (MH == CurHUD)
    {
        MH->Text->Clear();      
        CurHUD = MH->OldHUD;
    }
  }

  if (PhraseWaiting)
    AddPhraseToMH(DelayedMHText);

  strcpy(DelayedMHText, MessageText);
  PhraseWaiting = true;
#endif

        #undef MessageText
        break;
      }
    case AddMBText_:
      {
        #define MessageText PS(0)

#ifndef _IDE
  if (!PhraseWaiting)
  {
    strcpy(DelayedMHText, MessageText);
    PhraseWaiting = true;
  }
  else
    strcat(DelayedMHText, MessageText);
#endif

        #undef MessageText
        break;
      }
    case ShowMessageBox_:
      {

#ifndef _IDE
  if (!MH)
  {
     MH = PrepareMessageBox(mbsOK);
     AddPhraseToMH("");
  }
  else
  {
    if (MH == CurHUD)
    {
        MH->Text->Clear();      
        CurHUD = MH->OldHUD;
    }
  }

  if (PhraseWaiting)
  {
    AddPhraseToMH(DelayedMHText);
    PhraseWaiting = false;
  }
  
  Return(MH->Run();)
  MH = NULL;
#endif

        break;
      }
    case PlaySound_:
      {
        #define Sound PS(0)

#ifndef _IDE
  MainSoundManager->AddPhraseSound(Sound);
#endif

        #undef Sound
        break;
      }
    case PlayMercPhrase_:
      {
        #define MercName PS(0)
        #define Phrase PS(1)
        #define Sound PS(2)
        #define Color P(3)
        #define Pause P(4)

#ifndef _IDE
    RECORDABLE
	
	int DelayTime = SoundLength(Sound, false, false);
    DelayTime = DelayTime < 2 ? 2 : DelayTime;

    MainSoundManager->AddPhraseSound(Sound);

	// Let's find valid subtitle

	const char *Subtitle = Phrase;
	
	const char *ValidSubtitle = TryGetSubtitleForSound(Sound);
	if (ValidSubtitle)
		Subtitle = ValidSubtitle;

    GMList *M = AllMonsters->FindMonsterByName(MercName);
    ZMonster *This = (M ? M->This : GetMonsterByName(MercName));
    if (This)
	{
		MercPhraseControlData::AddToCurrentHUD(This->FaceMap, Subtitle, DelayTime, Color);

	  	if ((Pause != 0) && !MULTIPLAYER)
		{
			if (!App->MainPauser.IsInAnyPause())
				App->MainPauser.HardPause();
		}
	}
#else
#endif

        #undef MercName
        #undef Phrase
        #undef Sound
        #undef Color
        #undef Pause
        break;
      }
    case DisplayMercPhrase_:
      {
        #define MercName PS(0)
        #define Phrase PS(1)
        #define DelayTime P(2)
        #define Color P(3)
        #define Pause P(4)

#ifndef _IDE
	RECORDABLE
	
	GMList *M = AllMonsters->FindMonsterByName(MercName);
	ZMonster *This = (M ? M->This : GetMonsterByName(MercName));
	if (This)
	{
		ZMonster *WhoAreWeTalkingTo = GetMonsterByGUMID(WhoAreWeTalkingToGUMID);

		if (WhoAreWeTalkingTo && !strcmp(WhoAreWeTalkingTo->Name, MercName))
			This = WhoAreWeTalkingTo;
		
		assert(This->FaceMap);
		MercPhraseControlData::AddToCurrentHUD(This->FaceMap, Phrase, DelayTime, Color);

		if ((Pause != 0) && !MULTIPLAYER)
		{
			if (!App->MainPauser.IsInAnyPause())
				App->MainPauser.HardPause();
		}
	}
#else
#endif

        #undef MercName
        #undef Phrase
        #undef DelayTime
        #undef Color
        #undef Pause
        break;
      }
    case AssertMessageBox_:
      {
        #define Msg PS(0)

  MessageBox(NULL, Msg, "E5 Quest system assert", MB_OK | MB_ICONWARNING | MB_APPLMODAL);

        #undef Msg
        break;
      }
    case PrintToFile_:
      {
        #define Msg PS(0)

  Trace(TR_USUAL, "Quest trace: %s", Msg);

#ifdef _DEBUG
{
	assert(!"Delete me!");

	FILE *f = fopen("QuestAssert.txt", "a+");
	if(f)
	{
		fprintf(f, "%s  %s\n", TimeManager->GetPhysicalTimeString(), Msg);
		fclose(f);
	}
}
#endif



        #undef Msg
        break;
      }
    case SetHelpString_:
      {
        #define Text PS(0)
        #define Color P(1)

  if ((HUDState == hsMain) && MainHUD)
    MainHUD->SetQuestHelpString(Text, Color);

        #undef Text
        #undef Color
        break;
      }
    case ForceLoadAISquads_:
      {
        #define Side P(0)


        #undef Side
        break;
      }
    case AllPatrolsInSectorBecomeHostile_:
      {
        #define Side P(0)


        #undef Side
        break;
      }
    case BecomeHostile_:
      {
        #define Name PS(0)


        #undef Name
        break;
      }
    case SetNPCAttitude_:
      {
        #define Name PS(0)
        #define Att P(1)


        #undef Name
        #undef Att
        break;
      }
    case QuestGroupBecomeHostile_:
      {
        #define GroupID P(0)


        #undef GroupID
        break;
      }
    case SetAttitudeBetweenMonsterAndQuestGroup_:
      {
        #define PersonName PS(0)
        #define GroupID P(1)
        #define Att P(2)


        #undef PersonName
        #undef GroupID
        #undef Att
        break;
      }
    case SetPersonsAttitude_:
      {
        #define Person1Name PS(0)
        #define Person2Name PS(1)
        #define Att P(2)


        #undef Person1Name
        #undef Person2Name
        #undef Att
        break;
      }
    case GetAttitudeBetweenGlobalSides_:
      {
        #define Side1 P(0)
        #define Side2 P(1)


        #undef Side1
        #undef Side2
        break;
      }
    case __SetAttitudesBetweenGlobalSides_:
      {
        #define Side1 P(0)
        #define Side2 P(1)
        #define Att P(2)


        #undef Side1
        #undef Side2
        #undef Att
        break;
      }
    case SetAttitudesBetweenPlayerAndGlobalSides_:
      {
        #define NDFAtt P(0)
        #define GeneralAtt P(1)
        #define ContraAtt P(2)


        #undef NDFAtt
        #undef GeneralAtt
        #undef ContraAtt
        break;
      }
    case AllQuestGroupsInCurrentSectorBecomeHostile_:
      {
        #define Side P(0)


        #undef Side
        break;
      }
    case StdExp_:
      {
        #define Delay P(0)
        #define Speed P(1)


        #undef Delay
        #undef Speed
        break;
      }
    case GetTeamSize_:
      {


        break;
      }
    case GetTeamMember_:
      {
        #define Index P(0)


        #undef Index
        break;
      }
    case DelFromTeam_:
      {
        #define ThisName PS(0)


        #undef ThisName
        break;
      }
    case AddInTeam_:
      {
        #define ThisName PS(0)


        #undef ThisName
        break;
      }
    case SetExternQuestSide_:
      {
        #define QuestSide P(0)


        #undef QuestSide
        break;
      }
    case GetNumberOfPatients_:
      {
        #define DoctorName PS(0)


        #undef DoctorName
        break;
      }
    case GetPatient_:
      {
        #define DoctorName PS(0)
        #define Index P(1)


        #undef DoctorName
        #undef Index
        break;
      }
    case AddPatient_:
      {
        #define DoctorName PS(0)
        #define ThisName PS(1)
        #define ThisININame PS(2)


        #undef DoctorName
        #undef ThisName
        #undef ThisININame
        break;
      }
    case DelPatient_:
      {
        #define DoctorName PS(0)
        #define ThisName PS(1)


        #undef DoctorName
        #undef ThisName
        break;
      }
    case InitNPCs_:
      {
        #define Name PS(0)
        #define side P(1)


        #undef Name
        #undef side
        break;
      }
    case SetNear_:
      {
        #define Name PS(0)
        #define toWhom PS(1)


        #undef Name
        #undef toWhom
        break;
      }
    case GoTo_:
      {
        #define Name PS(0)
        #define toWhom PS(1)


        #undef Name
        #undef toWhom
        break;
      }
    case GoToPlace_:
      {
        #define Name PS(0)
        #define Place PS(1)


        #undef Name
        #undef Place
        break;
      }
    case SetToPlace_:
      {
        #define Name PS(0)
        #define Place PS(1)


        #undef Name
        #undef Place
        break;
      }
    case GoAway_:
      {
        #define Name PS(0)


        #undef Name
        break;
      }
    case GoAwayQuestGroup_:
      {
        #define QuestGroupID P(0)


        #undef QuestGroupID
        break;
      }
    case DescribeQuest_:
      {
        #define _Status P(0)
        #define _ShortDesc PS(1)
        #define _LongDesc PS(2)
        #define _SectorName PS(3)
        #define _TownName PS(4)
        #define _ClientName PS(5)
        #define _DescInPhrase PS(6)
        #define _Priority P(7)
        #define _Complexity P(8)
        #define _Riskiness P(9)
        #define _Ethicality P(10)


        #undef _Status
        #undef _ShortDesc
        #undef _LongDesc
        #undef _SectorName
        #undef _TownName
        #undef _ClientName
        #undef _DescInPhrase
        #undef _Priority
        #undef _Complexity
        #undef _Riskiness
        #undef _Ethicality
        break;
      }
    case Randomizer_:
      {
        #define Min P(0)
        #define Max P(1)


        #undef Min
        #undef Max
        break;
      }
    case SQRT100_:
      {
        #define Number P(0)


        #undef Number
        break;
      }
    case CallShop_:
      {
        #define _ShopName PS(0)
        #define PlayerName PS(1)
        #define Info PS(2)
        #define BuyProcCoef P(3)
        #define SellProcCoef P(4)
        #define UseCar P(5)


        #undef _ShopName
        #undef PlayerName
        #undef Info
        #undef BuyProcCoef
        #undef SellProcCoef
        #undef UseCar
        break;
      }
    case QuestMoneyChange_:
      {
        #define Money P(0)


        #undef Money
        break;
      }
    case HiringMoneyChange_:
      {
        #define Money P(0)


        #undef Money
        break;
      }
    case HireChar_:
      {
        #define Name1 PS(0)
        #define Name2 PS(1)
        #define Name3 PS(2)
        #define Name4 PS(3)
        #define Name5 PS(4)
        #define Name6 PS(5)


        #undef Name1
        #undef Name2
        #undef Name3
        #undef Name4
        #undef Name5
        #undef Name6
        break;
      }
    case CallBank_:
      {
        #define _ShopName PS(0)
        #define PlayerName PS(1)
        #define Info PS(2)
        #define BuyProcCoef P(3)
        #define SellProcCoef P(4)


        #undef _ShopName
        #undef PlayerName
        #undef Info
        #undef BuyProcCoef
        #undef SellProcCoef
        break;
      }
    case SetAttitude_:
      {
        #define Side1 P(0)
        #define Side2 P(1)
        #define Attitude P(2)


        #undef Side1
        #undef Side2
        #undef Attitude
        break;
      }
    case SetSectorForMonster_:
      {
        #define MercName PS(0)
        #define SectorName PS(1)


        #undef MercName
        #undef SectorName
        break;
      }
    case GetSectorForMonster_:
      {
        #define MercName PS(0)


        #undef MercName
        break;
      }
    case GetTownForMonster_:
      {
        #define MercName PS(0)


        #undef MercName
        break;
      }
    case LoadGroup_:
      {
        #define GroupFileName PS(0)
        #define QSide P(1)
        #define AttitudeToPlayer P(2)
        #define sType P(3)


        #undef GroupFileName
        #undef QSide
        #undef AttitudeToPlayer
        #undef sType
        break;
      }
    case AddToGroup_:
      {
        #define GroupFileName PS(0)
        #define GroupID P(1)
        #define sType P(2)


        #undef GroupFileName
        #undef GroupID
        #undef sType
        break;
      }
    case AddPersonToQuestGroup_:
      {
        #define Name PS(0)
        #define QuestGroupID P(1)


        #undef Name
        #undef QuestGroupID
        break;
      }
    case MergeQuestGroups_:
      {
        #define Group1ID P(0)
        #define Group2ID P(1)


        #undef Group1ID
        #undef Group2ID
        break;
      }
    case SetSectorState_:
      {
        #define SectorName PS(0)
        #define Status P(1)


        #undef SectorName
        #undef Status
        break;
      }
    case SetSectorOwner_:
      {
        #define SectorName PS(0)
        #define OwnerID P(1)


        #undef SectorName
        #undef OwnerID
        break;
      }
    case GetSectorOwner_:
      {
        #define SectorName PS(0)


        #undef SectorName
        break;
      }
    case AddAttackOrder_:
      {
        #define SideID P(0)
        #define SectorName PS(1)
        #define aOuterPriority P(2)
        #define aOuterUrgency P(3)
        #define _MinMercs P(4)
        #define _MaxMercs P(5)
        #define CasualtyToStop P(6)
        #define OrderName PS(7)


        #undef SideID
        #undef SectorName
        #undef aOuterPriority
        #undef aOuterUrgency
        #undef _MinMercs
        #undef _MaxMercs
        #undef CasualtyToStop
        #undef OrderName
        break;
      }
    case AddDefendOrder_:
      {
        #define SideID P(0)
        #define SectorName PS(1)
        #define aOuterPriority P(2)
        #define aOuterUrgency P(3)
        #define _MinMercs P(4)
        #define _MaxMercs P(5)
        #define CasualtyToStop P(6)
        #define OrderName PS(7)


        #undef SideID
        #undef SectorName
        #undef aOuterPriority
        #undef aOuterUrgency
        #undef _MinMercs
        #undef _MaxMercs
        #undef CasualtyToStop
        #undef OrderName
        break;
      }
    case CancelOrder_:
      {
        #define SideID P(0)
        #define OrderName PS(1)


        #undef SideID
        #undef OrderName
        break;
      }
    case CreateSquadWithPatrolOrder_:
      {
        #define SideID P(0)
        #define InitSectorName PS(1)
        #define DestinationSectorName PS(2)
        #define MercsNum P(3)
        #define OrderName PS(4)


        #undef SideID
        #undef InitSectorName
        #undef DestinationSectorName
        #undef MercsNum
        #undef OrderName
        break;
      }
    case ChangeSquadDirection_:
      {
        #define SideID P(0)
        #define SquadID P(1)
        #define SectorName PS(2)
        #define OrderName PS(3)


        #undef SideID
        #undef SquadID
        #undef SectorName
        #undef OrderName
        break;
      }
    case GetSquadSector_:
      {
        #define SideID P(0)
        #define SquadID P(1)


        #undef SideID
        #undef SquadID
        break;
      }
    case AddCar_:
      {
        #define CarName PS(0)


        #undef CarName
        break;
      }
    case GarrisonForSector_:
      {
        #define SectorName PS(0)
        #define SideID P(1)


        #undef SectorName
        #undef SideID
        break;
      }
    case SetVisibleForSector_:
      {
        #define SectorName PS(0)
        #define _Visible P(1)


        #undef SectorName
        #undef _Visible
        break;
      }
    case SetPosForSector_:
      {
        #define SectorName PS(0)
        #define _X P(1)
        #define _Y P(2)


        #undef SectorName
        #undef _X
        #undef _Y
        break;
      }
    case SetRandomPosForSector_:
      {
        #define SectorName PS(0)
        #define _MIN_X P(1)
        #define _MAX_X P(2)
        #define _MIN_Y P(3)
        #define _MAX_Y P(4)


        #undef SectorName
        #undef _MIN_X
        #undef _MAX_X
        #undef _MIN_Y
        #undef _MAX_Y
        break;
      }
    case GetQuestGroupBySquad_:
      {
        #define squadid P(0)


        #undef squadid
        break;
      }
    case SetQuestGroupsAttitude_:
      {
        #define Group1 P(0)
        #define Group2 P(1)
        #define Att P(2)


        #undef Group1
        #undef Group2
        #undef Att
        break;
      }
    case SetAttitudeBetweenQuestgroupAndGlobalSide_:
      {
        #define GroupID P(0)
        #define SideID P(1)
        #define Att P(2)


        #undef GroupID
        #undef SideID
        #undef Att
        break;
      }
    case SetReactionOnShooting_:
      {
        #define Name PS(0)
        #define State P(1)


        #undef Name
        #undef State
        break;
      }
    case AddSmallCoverWithCoords_:
      {
        #define FileName PS(0)
        #define X P(1)
        #define Y P(2)
        #define Z P(3)
        #define Rotation P(4)


        #undef FileName
        #undef X
        #undef Y
        #undef Z
        #undef Rotation
        break;
      }
    case RemoveAIGroupByID_:
      {
        #define GroupID P(0)


        #undef GroupID
        break;
      }
    case KillAIGroup_:
      {
        #define GroupID P(0)


        #undef GroupID
        break;
      }
    case MurderNPC_:
      {
        #define Name PS(0)


        #undef Name
        break;
      }
    case IsEnemiesInCurrentSector_:
      {


        break;
      }
    case IsNPCVisibleByGroup_:
      {
        #define Name PS(0)
        #define GroupID P(1)
        #define Range P(2)


        #undef Name
        #undef GroupID
        #undef Range
        break;
      }
    case PlaceQuestGroupRandomlyForAttackOrDefend_:
      {
        #define QuestGroupID P(0)
        #define Attack P(1)


        #undef QuestGroupID
        #undef Attack
        break;
      }
    case PlaceQuestGroupRandomlyAroundMerc_:
      {
        #define QuestGroupID P(0)
        #define MercName PS(1)
        #define MinRadius P(2)
        #define MaxRadius P(3)


        #undef QuestGroupID
        #undef MercName
        #undef MinRadius
        #undef MaxRadius
        break;
      }
    case PlaceQuestGroupRandomlyAroundPlace_:
      {
        #define QuestGroupID P(0)
        #define PlaceName PS(1)
        #define MinRadius P(2)
        #define MaxRadius P(3)


        #undef QuestGroupID
        #undef PlaceName
        #undef MinRadius
        #undef MaxRadius
        break;
      }
    case SetUserFollowPlan_:
      {
        #define Name PS(0)
        #define GroupID P(1)


        #undef Name
        #undef GroupID
        break;
      }
    case SetNPCFollowPlan_:
      {
        #define ThisName PS(0)
        #define FollowerName PS(1)


        #undef ThisName
        #undef FollowerName
        break;
      }
    case GetPlaceForMonster_:
      {
        #define MonsterName PS(0)


        #undef MonsterName
        break;
      }
    case GiveExplosive_:
      {
        #define MonsterName PS(0)
        #define Explosive PS(1)


        #undef MonsterName
        #undef Explosive
        break;
      }
    case AddGuards_:
      {
        #define QuestSide P(0)
        #define Percent P(1)


        #undef QuestSide
        #undef Percent
        break;
      }
    case MakeQuestPlaceVisibly_:
      {
        #define PlaceName PS(0)
        #define Description PS(1)
        #define aVisible P(2)


        #undef PlaceName
        #undef Description
        #undef aVisible
        break;
      }
    case SetMainPlayer_:
      {
        #define Name PS(0)


        #undef Name
        break;
      }
    case SwitchAllLights_:
      {
        #define State P(0)


        #undef State
        break;
      }
    case BlockDoorsInRadius_:
      {
        #define Name PS(0)
        #define Radius P(1)
        #define State P(2)


        #undef Name
        #undef Radius
        #undef State
        break;
      }
    case BlockDoorsInPlaceRadius_:
      {
        #define PlaceName PS(0)
        #define Radius P(1)
        #define State P(2)


        #undef PlaceName
        #undef Radius
        #undef State
        break;
      }
    case CheckWeaponInHands_:
      {
        #define Name PS(0)


        #undef Name
        break;
      }
    case ClearNPCActions_:
      {
        #define Name PS(0)


        #undef Name
        break;
      }
    case AddMessageToLog_:
      {
        #define Event PS(0)


        #undef Event
        break;
      }
    case SetRarityLimit_:
      {
        #define Limit P(0)


        #undef Limit
        break;
      }
    case AddToShopItems_:
      {
        #define ShopName PS(0)
        #define ItemName PS(1)
        #define Number P(2)
        #define ShopType P(3)


        #undef ShopName
        #undef ItemName
        #undef Number
        #undef ShopType
        break;
      }
    case GetItemNumber_:
      {
        #define ShopName PS(0)
        #define ItemName PS(1)


        #undef ShopName
        #undef ItemName
        break;
      }
    case ChangeShopItemsCoefs_:
      {
        #define ShopName PS(0)
        #define ItemName PS(1)
        #define NewProductivity P(2)
        #define NewProbability P(3)


        #undef ShopName
        #undef ItemName
        #undef NewProductivity
        #undef NewProbability
        break;
      }
    case ShowOutro_:
      {
        #define OutroNumber P(0)


        #undef OutroNumber
        break;
      }
    case Win_:
      {
        #define WinTypeID P(0)


        #undef WinTypeID
        break;
      }
    case DeathOfMainHero_:
      {
        #define Message PS(0)


        #undef Message
        break;
      }
    case ChangeActor_:
      {
        #define Name PS(0)
        #define Actor PS(1)


        #undef Name
        #undef Actor
        break;
      }
    case GetRarity_:
      {
        #define Level P(0)
        #define Value P(1)


        #undef Level
        #undef Value
        break;
      }
    case GetProbability_:
      {
        #define Level P(0)
        #define Value P(1)


        #undef Level
        #undef Value
        break;
      }
    case AddObject_:
      {
        #define ItemName PS(0)
        #define x P(1)
        #define y P(2)
        #define z P(3)
        #define Damage P(4)


        #undef ItemName
        #undef x
        #undef y
        #undef z
        #undef Damage
        break;
      }
    case AddObjectToPlace_:
      {
        #define ItemName PS(0)
        #define PlaceName PS(1)
        #define Damage P(2)


        #undef ItemName
        #undef PlaceName
        #undef Damage
        break;
      }
    case AddObjectNearMonster_:
      {
        #define ItemName PS(0)
        #define MonsterName PS(1)
        #define Damage P(2)


        #undef ItemName
        #undef MonsterName
        #undef Damage
        break;
      }
    case AddObjectToInventory_:
      {
        #define ItemName PS(0)
        #define Damage P(1)
        #define Receiver PS(2)


        #undef ItemName
        #undef Damage
        #undef Receiver
        break;
      }
    case DelObjectFomInventory_:
      {
        #define ItemName PS(0)
        #define MonsterName PS(1)


        #undef ItemName
        #undef MonsterName
        break;
      }
    case HasObjectInInventory_:
      {
        #define ItemName PS(0)
        #define Monster PS(1)


        #undef ItemName
        #undef Monster
        break;
      }
    case HasEnemiesInRadius_:
      {
        #define CenterMonster PS(0)
        #define Radius P(1)
        #define EnemyFor PS(2)


        #undef CenterMonster
        #undef Radius
        #undef EnemyFor
        break;
      }
    case SetMonsterToRandomPlace_:
      {
        #define Name PS(0)


        #undef Name
        break;
      }
    case GetPlayersFullName_:
      {


        break;
      }
    case GetDistFromMonsterToMonster_:
      {
        #define Name1 PS(0)
        #define Name2 PS(1)


        #undef Name1
        #undef Name2
        break;
      }
    case GetDistFromMonsterToPlace_:
      {
        #define Name1 PS(0)
        #define PlaceName PS(1)


        #undef Name1
        #undef PlaceName
        break;
      }
    case AddMonsterToNPCList_:
      {
        #define Name PS(0)
        #define Highlight P(1)


        #undef Name
        #undef Highlight
        break;
      }
    case GetSectorByPlace_:
      {
        #define PlaceName PS(0)


        #undef PlaceName
        break;
      }
    case GetQuestGroupSize_:
      {
        #define GroupID P(0)


        #undef GroupID
        break;
      }
    case Heal_:
      {
        #define ININame PS(0)


        #undef ININame
        break;
      }
    case ResetCameraEvents_:
      {


        break;
      }
    case GetMainSelectedName_:
      {


        break;
      }
    case MainSelectedClearActionsAndVisibility_:
      {


        break;
      }
    case IsHardPausedNow_:
      {


        break;
      }
    case AddWaitsToAllInactive_:
      {


        break;
      }
    case MainSelectedHasActions_:
      {


        break;
      }
    case RaiseAdrenalineForMainSelected_:
      {


        break;
      }
    case GetDateString_:
      {


        break;
      }
    case AllPatrolsInSectorBecomePeaceful_:
      {
        #define Side P(0)


        #undef Side
        break;
      }
    case GetActualLevel_:
      {
        #define ThisItem PS(0)


        #undef ThisItem
        break;
      }
    case GetActualSubLevel_:
      {
        #define ThisItem PS(0)


        #undef ThisItem
        break;
      }
    case GetCreditCardsNumber_:
      {
        #define Name PS(0)
        #define CreditCardType P(1)


        #undef Name
        #undef CreditCardType
        break;
      }
    case GetGoldNumber_:
      {
        #define Name PS(0)
        #define GoldType P(1)


        #undef Name
        #undef GoldType
        break;
      }
    case GetWIHName_:
      {
        #define Name PS(0)


        #undef Name
        break;
      }
    case GetWIHCondition_:
      {
        #define Name PS(0)


        #undef Name
        break;
      }
    case RepairWIH_:
      {
        #define Name PS(0)


        #undef Name
        break;
      }
    default:
      {
        ErrorMessage("Unknown", erCompiler, "Error in UserFunc: unknown IDCode %i\n", IDCode);
        Res = 0;
        break;
      }
  }

}
#undef P
#undef PS
#undef Res

//Warning!!! All variables mentioned here should be declared somewhere.

void InitExternalFlagsA()
{
  int ___E1P_Array_Index___;
  Flag(qdescComplexity_) = qdescComplexity;
  Flag(qdescRisk_) = qdescRisk;
  Flag(qdescEthic_) = qdescEthic;
  Flag(GameType_) = GameType;
  Flag(MaxCivilians_) = MaxCivilians;
  Flag(StartSide_) = StartSide;
  Flag(WarStarted_) = WarStarted;
  Flag(CombatSquadID_) = CombatSquadID;
  Flag(Contract7_) = Contract7;
  Flag(Contract14_) = Contract14;
  Flag(Contract21_) = Contract21;
  Flag(CurrentMercContract_) = CurrentMercContract;
  Flag(CanLeaveCurrentSector_) = CanLeaveCurrentSector;
  Flag(CurrentGameLevel_) = CurrentGameLevel;
  Flag(CurrentGameLevelProgress_) = CurrentGameLevelProgress;
  Flag(MainPlayerQuestSide_) = MainPlayerQuestSide;
  Flag(TutorialFlagNoDamageToEnemy_) = TutorialFlagNoDamageToEnemy;
  Flag(CheatQuestStatus_) = CheatQuestStatus;
  strcpy(StringFlag(qdescQuestOwnerName_), qdescQuestOwnerName);
  strcpy(StringFlag(qdescShortQuestDescription_), qdescShortQuestDescription);
  strcpy(StringFlag(CurrentSector_), CurrentSector);
  strcpy(StringFlag(WhoTalkWithNPC_), WhoTalkWithNPC);
  strcpy(StringFlag(LANG_Profile_), LANG_Profile);
  strcpy(StringFlag(CheatQuestName_), CheatQuestName);

  for(___E1P_Array_Index___ = 0; ___E1P_Array_Index___<11; ___E1P_Array_Index___++)
    Flag(GameComplexity_+___E1P_Array_Index___) = GameComplexity[___E1P_Array_Index___];
}

void RestoreExternalFlagsA()
{
  int ___E1P_Array_Index___;
  qdescComplexity = Flag(qdescComplexity_);
  qdescRisk = Flag(qdescRisk_);
  qdescEthic = Flag(qdescEthic_);
  GameType = Flag(GameType_);
  MaxCivilians = Flag(MaxCivilians_);
  StartSide = Flag(StartSide_);
  WarStarted = Flag(WarStarted_);
  CombatSquadID = Flag(CombatSquadID_);
  Contract7 = Flag(Contract7_);
  Contract14 = Flag(Contract14_);
  Contract21 = Flag(Contract21_);
  CurrentMercContract = Flag(CurrentMercContract_);
  CanLeaveCurrentSector = Flag(CanLeaveCurrentSector_);
  CurrentGameLevel = Flag(CurrentGameLevel_);
  CurrentGameLevelProgress = Flag(CurrentGameLevelProgress_);
  MainPlayerQuestSide = Flag(MainPlayerQuestSide_);
  TutorialFlagNoDamageToEnemy = Flag(TutorialFlagNoDamageToEnemy_);
  CheatQuestStatus = Flag(CheatQuestStatus_);
  strcpy(qdescQuestOwnerName, StringFlag(qdescQuestOwnerName_));
  strcpy(qdescShortQuestDescription, StringFlag(qdescShortQuestDescription_));
  strcpy(CurrentSector, StringFlag(CurrentSector_));
  strcpy(WhoTalkWithNPC, StringFlag(WhoTalkWithNPC_));
  strcpy(LANG_Profile, StringFlag(LANG_Profile_));
  strcpy(CheatQuestName, StringFlag(CheatQuestName_));

  for(___E1P_Array_Index___ = 0; ___E1P_Array_Index___<11; ___E1P_Array_Index___++)
    GameComplexity[___E1P_Array_Index___] = Flag(GameComplexity_+___E1P_Array_Index___);
}
